<%@ WebHandler Language="C#" Class="Handler" %>
 
using System;
using System.Web;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;
using System.Linq;
using System.Collections.Generic;
using System.Web.Script.Serialization;
 
public class Handler : IHttpHandler
{
    public static List<customers> customer = new List<customers>();
    string methodname = string.Empty;
    string callbackmethodname = string.Empty;
    string parameter = string.Empty;
    
    public void ProcessRequest(HttpContext context)
    {
        string callback = context.Request.QueryString["callback"];
        int customerId = 0;
        int.TryParse(context.Request.QueryString["customerId"], out customerId);
        string json = this.GetCustomersJSON(customerId);
        if (!string.IsNullOrEmpty(callback))
        {
            json = string.Format("{0}({1});", callback, json);
        }
       
        context.Response.ContentType = "text/json";
        methodname = context.Request.Params["method"];
        parameter = context.Request.Params["param"];
        callbackmethodname = context.Request.Params["callbackmethod"];

        if (methodname == null)
           context.Response.Write(json);
          
        else{
             switch (methodname.ToLower())
            {

               
                case "insert":

                    context.Response.Write(Insert(context));

                    break;

                case "update":

                    context.Response.Write(Update(context));

                    break;

                case "delete":

                    context.Response.Write(Delete(int.Parse(context.Request.Params["Id"])));

                    break;

            }
        }
         
    }

    
    private string GetCustomersJSON(int customerId)
    {

        if (customer.Count() == 0) {
           customer.Add(new customers(1, "ALFKI", 0, "Berlin"));
           customer.Add(new customers(2, "ANATR",  2,"Madrid"));
           customer.Add(new customers(3, "ANTON",  1, "Cholchester"));
           customer.Add(new customers(4, "BLONP", 3, "Marseille"));
           customer.Add(new customers(5, "BOLID", 4, "Tsawassen")); 
    }
        
        return (new JavaScriptSerializer().Serialize(customer));
    }

    public class customers
    {
        public customers()
        {

        }
        public customers(int OrderID, string CustomerID, int EmployeeID, string ShipCity)
        {
            this.OrderID = OrderID;
            this.CustomerID = CustomerID;
            this.EmployeeID = EmployeeID;
            this.ShipCity = ShipCity;
        }
        public int OrderID { get; set; }
        public string CustomerID { get; set; }
        public int EmployeeID { get; set; }
        public string ShipCity { get; set; }
    }

   
        public object Insert(HttpContext context)

        {

         JsonResponse response = new JsonResponse();
            try
               {
               customers cust = new customers  
                   {

                    OrderID = Convert.ToInt16(context.Request.Params["OrderID"]),

                    CustomerID= context.Request.Params["CustomerID"],


                    EmployeeID = Convert.ToInt16(context.Request.Params["EmployeeID"]),

                    ShipCity = context.Request.Params["ShipCity"]

                  };

                customer.Add(cust);

                response.IsSuccess = true;

                response.Data = cust;

                response.Message = "customer inserted successfully!";

                response.CallBack = callbackmethodname;

            }

            catch (Exception ex)

            {

                response.IsSuccess = false;

                response.Message = ex.Message;

            }



            return (new JavaScriptSerializer().Serialize(customer));

        }


        public string Update(HttpContext context)
        {

            JsonResponse response = new JsonResponse();

            try
                {
                     
                
                     int id = int.Parse(context.Request.Params["OrderID"]);

                     customers cust = customer.FirstOrDefault(m => m.OrderID== id);

                     cust.CustomerID= context.Request.Params["CustomerID"];

                     cust.EmployeeID = Convert.ToInt16(context.Request.Params["EmployeeID"]);

                     cust.ShipCity = context.Request.Params["ShipCity"];

                     response.IsSuccess = true;

                     response.Data = cust;

                     response.Message = "Customer updated successfully!";

                     response.CallBack = callbackmethodname;

               }

               catch (Exception ex) {

                response.IsSuccess = false;

                response.Message = ex.Message;

               }

                  return (new JavaScriptSerializer().Serialize(customer));
 
           }



        public string Delete(int id)
        {

            JsonResponse response = new JsonResponse();
           
          try
            {
                
                 customers cust = customer.FirstOrDefault(m => m.OrderID == id);

                if (cust != null)
                {

                    customer.Remove(cust);

                    response.IsSuccess = true;

                    response.CallBack = callbackmethodname;

                    response.Data = "Customer Deleted successfully!";

                    response.Message = "Customer Deleted successfully!";

                }

                else
                {

                    response.IsSuccess = false;

                    response.Message = "Customer not exist!";

                }

            }

            catch (Exception ex)
            {

                response.IsSuccess = false;

                response.Message = ex.Message;

            }



            return (new JavaScriptSerializer().Serialize(customer));

        }

   
     public class JsonResponse

    {

        public bool IsSuccess { get; set; }

        public string Message { get; set; }

        public object Data { get; set; }

        public string CallBack { get; set; }

    }

    
    public bool IsReusable
    {
        get
        {
            return false;
        }
    }
}